/*
 * Copyright © 2023 Imagination Technologies Ltd.
 * SPDX-License-Identifier: MIT
 */

#include "util/os_file.h"
#include "util/u_screen.h"

#include "zink_drm_public.h"
#include "zink/zink_public.h"

struct pipe_screen *
zink_drm_create_screen(int fd, const struct pipe_screen_config *config)
{
   return zink_create_screen(os_dupfd_cloexec(fd), config, NULL);
}

struct pipe_screen *
zink_drm_create_screen_renderonly(int fd,
                                  struct renderonly *ro,
                                  const struct pipe_screen_config *config)
{
   return u_pipe_screen_lookup_or_create(os_dupfd_cloexec(fd), config, ro, zink_create_screen);
}
