/*
 * Copyright © 2022 Imagination Technologies Ltd.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

#ifndef PVR_CDM_LOAD_SR_H
#define PVR_CDM_LOAD_SR_H

#include <stdint.h>

/* clang-format off */
static const uint8_t pvr_cdm_load_sr_code[] = {
   0x25, 0x02, 0x87, 0x81,
   0x04, 0x00, 0x00, 0x00,
   0x84, 0x04, 0x25, 0x02,
   0x87, 0x80, 0x04, 0x00,
   0x00, 0x00, 0x85, 0x04,
   0x25, 0x02, 0x87, 0x83,
   0x04, 0x00, 0x00, 0x00,
   0x86, 0x04, 0x25, 0x02,
   0x87, 0x82, 0x04, 0x00,
   0x00, 0x00, 0x87, 0x04,
   0x56, 0x20, 0xf1, 0x85,
   0x00, 0x80, 0x81, 0xd0,
   0xc4, 0x08, 0x00, 0xff,
   0x02, 0x80, 0x6a, 0xff,
   0x67, 0xf0, 0x40, 0x20,
   0x41, 0x8c, 0x80, 0x40,
   0x00, 0x50, 0x8f, 0xc0,
   0x80, 0x02, 0x04, 0x81,
   0x60, 0x00, 0x9a, 0x00,
   0x00, 0x00, 0x25, 0x36,
   0x87, 0x87, 0x00, 0x00,
   0x40, 0x05, 0xd1, 0x06,
   0x55, 0x20, 0xf1, 0x81,
   0x00, 0x00, 0xc0, 0xc6,
   0x08, 0x00, 0x02, 0x80,
   0x6a, 0xff, 0x46, 0x42,
   0xd0, 0x03, 0xea, 0xd1,
   0x41, 0x00, 0x01, 0x00,
   0x00, 0x51, 0x27, 0x06,
   0xeb, 0x84, 0x50, 0x20,
   0x86, 0x87, 0x04, 0x00,
   0xc0, 0x06, 0x87, 0x22,
   0x25, 0x32, 0x87, 0x87,
   0x00, 0x1f, 0x40, 0xc5,
   0x0c, 0xff, 0x25, 0x02,
   0x87, 0xc0, 0x0c, 0x00,
   0x00, 0x00, 0x83, 0x0c,
   0x47, 0x42, 0xd0, 0x03,
   0xea, 0x85, 0x41, 0x90,
   0x01, 0x08, 0x00, 0x00,
   0x85, 0x0c, 0x47, 0x42,
   0xd0, 0x03, 0xea, 0xc5,
   0x41, 0x90, 0x01, 0x08,
   0x00, 0x00, 0xc5, 0x0c,
   0x67, 0xf0, 0x40, 0x28,
   0x42, 0x8c, 0x80, 0x40,
   0x80, 0xc5, 0x80, 0x90,
   0x80, 0xff, 0x04, 0x81,
   0x60, 0x00, 0xcc, 0xff,
   0xff, 0xff, 0x66, 0xf0,
   0x40, 0x28, 0x42, 0x8c,
   0x80, 0x40, 0x00, 0x51,
   0xd0, 0x80, 0x07, 0x81,
   0x60, 0x00, 0x86, 0xff,
   0xff, 0xff, 0xf3, 0xff,
   0xff, 0xff, 0xff, 0xff,
   0x04, 0x80, 0xee, 0x00,
   0xf2, 0xff, 0xff, 0xff,
};
/* clang-format on */

#endif /* PVR_CDM_LOAD_SR_H */
